
/*
 *
  Copyright (c) Eicon Networks, 2005.
 *
  This source file is supplied for the use with
  Eicon Networks range of DIVA Server Adapters.
 *
  Eicon File Revision :    2.1
 *
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2, or (at your option)
  any later version.
 *
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY OF ANY KIND WHATSOEVER INCLUDING ANY
  implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  See the GNU General Public License for more details.
 *
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
#include "platform.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "dbgioctl.h"
/*****************************************************************************/
void
rtpAnalyse (FILE *out, DbgMessage *msg, int real_message_length)
{
 unsigned char *buffer = &msg->data[0] ;
 char           line[1024] ;
 long           i, len = msg->size ;

 int rtp_v, rtp_p, rtp_x, rtp_cc, rtp_m, rtp_pt, rtp_sequence_number, rtp_timestamp, rtp_ssrc ;
/*
 * Check length of buffer against length of frame
 */
 if ( len < 12 )
  return ;
 rtp_v = (byte)buffer[0] & 3;
 if (rtp_v != 2)
	 return ;
 rtp_p = ((byte)buffer[0] >> 2) & 1;
 rtp_x = ((byte)buffer[0] >> 3) & 1;
 rtp_cc = (byte)buffer[0] >> 4;
 rtp_m = (byte)buffer[1] & 1;
 rtp_pt = (byte)buffer[1] >> 1;
 rtp_sequence_number = (short int)buffer[1];
 rtp_timestamp = (int)buffer[1];
 rtp_ssrc = (int)buffer[2];

 sprintf (line, "\n  RTP : pt %2d, sequence number %4x, timestamp %8x, ssrc %8x",
	 rtp_pt, rtp_sequence_number, rtp_timestamp, rtp_ssrc) ;
 fputs (&line[0], out) ;
 for (i=0; i<rtp_cc; i++) {
	 sprintf (line, ", csrc%ld %8x", i, (int)buffer[3+i]);
	 fputs (&line[0], out) ;
 }

 fputs ("\n", out) ;

}
