#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>
#include <sys/mman.h>
#include "platform.h"

extern int silent_operation;
extern FILE* VisualStream;

static FILE *InStream = 0;
dword buffer_size;

byte *memorymap(char *filename) {
	int rb_fd;
	byte *rb = NULL;

	FILE* InStream = fopen (filename, "r+");

	if (!InStream) {
		if (!silent_operation)
			perror ("Input File");
		return (byte *)(-1);
	}

	rb_fd = fileno (InStream);
	if (rb_fd < 0) {
		if (!silent_operation)
			perror ("Input  File");
		fclose (InStream);
		InStream = 0;
		return (byte *)(-1);
	}

	buffer_size = (dword)lseek(rb_fd, 0, SEEK_END);
	lseek (rb_fd, 0, SEEK_SET);

	if (buffer_size < 4096) {
		fprintf (VisualStream, "ERROR: Invalid File Format\n");
		fclose (InStream);
		InStream = 0;
		return (byte *)(-1);
	}

	if (!(rb = (byte*)mmap (0, buffer_size, PROT_READ | PROT_WRITE, MAP_PRIVATE, rb_fd, 0))) {
		if (!silent_operation)
			perror ("Input Buffer");
		fclose (InStream);
		InStream = 0;
		return (byte *)(-1);
	}

    return (rb);
}

void unmemorymap(byte *map_base) {
	if (InStream != 0)
		fclose (InStream);
	InStream = 0;
	munmap(map_base, buffer_size);
}
